routes/web.php
<?php

use App\Http\Controllers\CustomerController;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Route;
use App\Http\Controllers\HomeController;
use App\Http\Controllers\ProductController;
use App\Http\Controllers\SettingController;
use App\Http\Controllers\OrderController;
use App\Http\Controllers\CartController;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

// Route::get('/', function () {
//   return view('welcome');
// });

Auth::routes();

Route::middleware(['auth'])->group(function () {
  Route::get('/',  [HomeController::class, 'index'])->name('dashboard');
  Route::get('/dashboard', [HomeController::class, 'index'])->name('dashboard');
  Route::resource('products', ProductController::class);
  Route::get('setting', [SettingController::class, 'index'])->name('setting.index');
  Route::post('setting', [SettingController::class, 'store'])->name('setting.store');
  Route::resource('customers', CustomerController::class);
  Route::resource('orders', OrderController::class);

  Route::get('/cart', [CartController::class, 'index'])->name('cart.index');
  // Route::get('/cart/{id}', [CartController::class, 'store'])->name('cart.store');
  Route::post('/cart', [CartController::class, 'store'])->name('cart.store');
  Route::get('/cart/{id}', [CartController::class, 'addToCart'])->name('add_to_cart');
  Route::patch('/cart/update', [CartController::class, 'updateCart'])->name('update_cart');
  Route::post('/cart/change-qty', [CartController::class, 'changeQty'])->name('changeQty');
  Route::delete('/cart/delete', [CartController::class, 'delete'])->name('cart.delete');
  Route::delete('/cart/empty', [CartController::class, 'empty']);
});

app/Models/order.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class order extends Model
{
  use HasFactory;

  protected $table = 'orders';

  protected $fillable = [
    'customer_id',
    'user_id'
  ];

  public function items()
  {
    return $this->hasMany(order_item::class);
  }

  public function payments()
  {
    return $this->hasMany(Payment::class);
  }

  public function customer()
  {
    return $this->belongsTo(Customer::class);
  }

  public function getCustomerName()
  {
    if ($this->customer) {
      return $this->customer->first_name . ' ' . $this->customer->last_name;
    }
    return 'Working Customer';
  }

  public function total()
  {
    return $this->items->map(function ($i) {
      return $i->price;
    })->sum();
  }

  public function formattedTotal()
  {
    return number_format($this->total(), 2);
  }

  public function receivedAmount()
  {
    return $this->payments->map(function ($i) {
      return $i->amount;
    })->sum();
  }

  public function formattedReceivedAmount()
  {
    return number_format($this->receivedAmount(), 2);
  }
}

app/Http/Controllers/OrderController.php
<?php

namespace App\Http\Controllers;

use App\Http\Requests\OrderStoreRequest;
use App\Models\order;
use Illuminate\Http\Request;

class OrderController extends Controller
{
  /**
   * Display a listing of the resource.
   *
   * @return \Illuminate\Http\Response
   */
  public function index(Request $request)
  {
    $orders = new Order();
    if ($request->start_date) {
      $orders = $orders->where('created_at', '>=', $request->start_date);
    }
    if ($request->end_date) {
      $orders = $orders->where('created_at', '<=', $request->end_date . ' 23:59:59');
    }
    $orders = $orders->with(['items', 'payments', 'customer'])->latest()->paginate(10);

    $total = $orders->map(function ($i) {
      return $i->total();
    })->sum();
    $receivedAmount = $orders->map(function ($i) {
      return $i->receivedAmount();
    })->sum();

    return view('orders.index', compact('orders', 'total', 'receivedAmount'));
  }

  /**
   * Show the form for creating a new resource.
   *
   * @return \Illuminate\Http\Response
   */

  public function store(OrderStoreRequest $request)
  {
    $order = Order::create([
      'customer_id' => $request->customer_id,
      'user_id' => $request->user()->id,
    ]);

    $cart = $request->user()->cart()->get();
    foreach ($cart as $item) {
      $order->items()->create([
        'price' => $item->price * $item->pivot->quantity,
        'quantity' => $item->pivot->quantity,
        'product_id' => $item->id,
      ]);
      $item->quantity = $item->quantity - $item->pivot->quantity;
      $item->save();
    }
    $request->user()->cart()->detach();
    $order->payments()->create([
      'amount' => $request->amount,
      'user_id' => $request->user()->id,
    ]);
    return 'success';
  }
}

resources/views/pages/order/create.blade.php
@extends('adminlte.master')

@section('title', 'Halaman Produk')

@section('content')
<div class="col-12">
  <div class="card">
  <div class="card-header">
    <h3 class="card-title">Tambah Produk</h3>
  </div>
  <!-- /.card-header -->
  <div class="card-body">
    <form action="/products" method="POST" enctype="multipart/form-data">
      @csrf

      <div class="form-group">
        <label for="name">Nama Produk</label>
        <input type="text" class="form-control" name="name" id="name" placeholder="Masukkan Nama Produk">
        @error('name')
        <div class="alert alert-danger">
          {{ $message }}
        </div>
        @enderror
      </div>

      <div class="form-group">
        <label for="description">Deskripsi Produk</label>
        <input type="text" class="form-control" name="description" id="description" placeholder="Masukkan Deskripsi Produk">
        @error('description')
        <div class="alert alert-danger">
          {{ $message }}
        </div>
        @enderror
      </div>

      <div class="form-group">
        <label for="image">Gambar Produk</label>
        <input type="file" class="form-control" name="image" id="image" placeholder="Masukkan File Image Produk">
        @error('image')
        <div class="alert alert-danger">
          {{ $message }}
        </div>
        @enderror
      </div>

      <div class="form-group">
        <label for="barcode">Barcode</label>
        <input type="text" class="form-control" name="barcode" id="barcode" placeholder="Masukkan Barcode Produk">
        @error('barcode')
        <div class="alert alert-danger">
          {{ $message }}
        </div>
        @enderror
      </div>

      <div class="form-group">
        <label for="price">Harga Produk</label>
        <input type="number" class="form-control" name="price" id="price" placeholder="Masukkan Harga Produk">
        @error('price')
        <div class="alert alert-danger">
          {{ $message }}
        </div>
        @enderror
      </div>

      <div class="form-group">
        <label for="quantity">Jumlah Produk</label>
        <input type="number" class="form-control" name="quantity" id="quantity" placeholder="Masukkan Jumlah Produk">
        @error('quantity')
        <div class="alert alert-danger">
          {{ $message }}
        </div>
        @enderror
      </div>

      <input type="text" class="form-control" value ="1" hidden name="status" id="status" placeholder="Masukkan Status">
       

      <button type="submit" class="btn btn-primary">Tambah</button>
    </form>

  </div>
  </div>
</div>
@endsection

resources/views/pages/order/edit.blade.php
@extends('adminlte.master')

@section('title', 'Halaman Produk')

@section('content')
<div class="col-12">
  <div class="card">
  <div class="card-header">
    <h3 class="card-title">Ubah Produk</h3>
  </div>
  <!-- /.card-header -->
  <div class="card-body">
    <form action="{{ route('products.update', $product->id) }}" method="POST" enctype="multipart/form-data">
      @csrf
      @method('PUT')
      <div class="form-group">
        <label for="name">Nama Produk</label>
        <input type="text" class="form-control" name="name" value="{{$product->name}}" id="name" placeholder="Masukkan Nama Produk">
        @error('name')
        <div class="alert alert-danger">
          {{ $message }}
        </div>
        @enderror
      </div>
      <div class="form-group">
        <label for="description">Deskripsi Produk</label>
        <input type="text" class="form-control" name="description" value="{{$product->description}}" id="description" placeholder="Masukkan Deskripsi Produk">
        @error('description')
        <div class="alert alert-danger">
          {{ $message }}
        </div>
        @enderror
      </div>
      <div class="form-group">
        <label for="image">Gambar Produk</label>
        <input type="file" class="form-control" name="image" value="{{$product->image}}" id="image" placeholder="Masukkan File Image Produk">
        @error('image')
        <div class="alert alert-danger">
          {{ $message }}
        </div>
        @enderror
      </div>
      <div class="form-group">
        <label for="barcode">Barcode</label>
        <input type="text" class="form-control" name="barcode" value="{{$product->barcode}}" id="barcode" placeholder="Masukkan Barcode Produk">
        @error('barcode')
        <div class="alert alert-danger">
          {{ $message }}
        </div>
        @enderror
      </div>
      <div class="form-group">
        <label for="price">Harga Produk</label>
        <input type="number" class="form-control" name="price" value="{{$product->price}}" id="price" placeholder="Masukkan Harga Produk">
        @error('price')
        <div class="alert alert-danger">
          {{ $message }}
        </div>
        @enderror
      </div>
      <div class="form-group">
        <label for="quantity">Jumlah Produk</label>
        <input type="number" class="form-control" name="quantity" value="{{$product->quantity}}" id="quantity" placeholder="Masukkan Jumlah Produk">
        @error('quantity')
        <div class="alert alert-danger">
          {{ $message }}
        </div>
        @enderror
      </div>

      <button type="submit" class="btn btn-primary">Update</button>
    </form>

  </div>
  </div>
</div>
@endsection

resources/views/pages/order/index.blade.php
@extends('adminlte.master')

@section('title', 'Halaman Order')

@section('content')
<div class="col-12">
  <div class="card">
    <div class="card-header">
      <h3 class="card-title">Datatables Order</h3>

      <div class="card-tools">
        <a href="{{ route('orders.create') }}" class="btn btn-tool btn-sm">
          <i class="fas fa-plus"></i>
        </a>
      </div>

    </div>
    <!-- /.card-header -->
    <div class="card-body">
      <table id="example1" class="table table-bordered table-striped">
        <thead>
          <tr>
            <th>No</th>
            <th>Nama Produk</th>
            <th>Harga Produk</th>
            <th>Action</th>

          </tr>
        </thead>
        <tbody>
          @foreach ($orders as $item)
          <tr>
            <td>{{ $loop->iteration }}</td>
            <td>{{ $item->name }}</td>
            <td>{{ $item->price }}</td>
            <td>
              <a href="{{ route('orders.edit', $item->id) }}" class="btn btn-secondary">
                <i class="fas fa-edit"></i>
              </a>
              <a href="{{ route('orders.show', $item->id)}} " class="btn btn-secondary">
                <i class="fas fa-eye"></i>
              </a>

              <a class="btn btn-danger" onclick="
                                var result = confirm('Are you sure you want to delete this record?');

                                if(result){
                                    event.preventDefault();
                                    document.getElementById('delete-form-{{$item->id}}').submit();
                                }">
                <i class="fas fa-trash"></i>
              </a>

              <form action="{{ route('orders.destroy', $item->id) }}" method="post" id="delete-form-{{$item->id}}">
                @method('DELETE')
                @csrf
              </form>
            </td>

          </tr>
          @endforeach
        </tbody>
      </table>
    </div>
    <!-- /.card-body -->
  </div>
</div>
@endsection

@push('scripts')
<script src=" {{ asset('plugins/datatables/jquery.dataTables.min.js') }}">
  <script src="{{ asset('plugins/datatables-bs4/js/dataTables.bootstrap4.min.js') }}">
</script>
<script src="{{ asset('plugins/datatables-responsive/js/dataTables.responsive.min.js') }}">
</script>
<script src="{{ asset('plugins/datatables-responsive/js/responsive.bootstrap4.min.js') }}">
</script>
<script src="{{ asset('plugins/datatables-buttons/js/dataTables.buttons.min.js') }}">
</script>
<script src="{{ asset('plugins/datatables-buttons/js/buttons.bootstrap4.min.js') }}">
</script>
<script src="{{ asset('plugins/jszip/jszip.min.js') }}">
</script>
<script src="{{ asset('plugins/pdfmake/pdfmake.min.js') }}">
</script>
<script src="{{ asset('plugins/pdfmake/vfs_fonts.js') }}">
</script>
<script src="{{ asset('plugins/datatables-buttons/js/buttons.html5.min.js') }}">
</script>
<script src="{{ asset('plugins/datatables-buttons/js/buttons.print.min.js') }}">
</script>
<script src="{{ asset('plugins/datatables-buttons/js/buttons.colVis.min.js') }}">
</script>

<script>
  $(function () {
        $("#example1").DataTable({
        "responsive": true, "lengthChange": false, "autoWidth": false,
        "buttons": ["copy", "csv", "excel", "pdf", "print", "colvis"]
        }).buttons().container().appendTo('#example1_wrapper .col-md-6:eq(0)');
    });
</script>

@endpush

resources/views/pages/order/show.blade.php
@extends('adminlte.master')

@section('title', 'Halaman Produk')

@section('content')
<div class="col-12">
  <div class="card">
  <div class="card-header">
    <h3 class="card-title">Tampilkan Produk</h3>
    <div class="card-tools">
      <a href="/products" class="btn btn-tool btn-sm btn-success">
        <i class="fas fa-arrow-left"></i>
      </a>
    </div>
  </div>
  <!-- /.card-header -->
  <div class="card-body">
    <strong><i class=""></i> Nama Produk</strong>
    <p class="text-muted">
      {{ $product->name }}
    </p>
    <hr>
    <strong><i class=""></i> Deskripsi Produk</strong>
    <p class="text-muted">
      {{ $product->description }}
    </p>
    <hr>
    <strong><i class=""></i> Foto Produk</strong>
    <p class="text-muted">
      <img src="{{ asset('.../image/' . $product->image) }}" alt="">
    </p>
    <hr>
    <strong><i class=""></i> Barcode</strong>
    <p class="text-muted">
      {{ $product->barcode }}
    </p>
    <hr>
    <strong><i class=""></i> Harga Produk</strong>
    <p class="text-muted">
      {{ $product->price }}
    </p>
    <hr>
    <strong><i class=""></i> Jumlah Produk</strong>
    <p class="text-muted">
      {{ $product->quantity }}
    </p>
    <hr>
  </div>
  </div>
</div>
@endsection